{ HDFORMAT - 11.03.1989 }

program hdformat;

const
{$i hdcdef.lib}
    track_length = 10416;
    CR           = #$0d;
    ESC          = #$1b;

type
    wrkstring    = string[80];
    str10        = string[10];

var
    gap3_len     : integer;
    Sekt_Size    : integer;
    Buffer       : array[1..1024] of Byte;
    maxtrack     : integer;
    maxsek       : integer;
    i,inter      : integer;
    ch           : char;
    errors       : integer;

{$i hdcrout.lib}

procedure Compute_Gap3_Len;
var k : integer;
begin
  if inter = 1 then k := 25 else k := 0;
  Gap3_Len := round((2 * Speedvar * Sektor_Laenge) / 100) + k;
  writeln; writeln;
  writeln ('Gap3 - Laenge = ',Gap3_Len);
end;

procedure Checkspace;
var k1,k2 : integer;
begin
  k1 := 43;
  k2 := Gap3_Len;
  k1 := k1 + Sektor_Laenge + k2;
  k1 := Sektoren_pro_Spur * k1;
  if k1 > Track_Length then
    abort ('Fehler : gewaehltes Format ist zu lang fuer eine Spur !');
end;

procedure Clear_Buffer;
var i : integer;
begin
  for i := 1 to Sektor_Laenge do buffer[i] := $e5;
end;

procedure Setup_Buffer;
var first, Sek_Num, i : integer;
begin
  writeln;
  repeat
    write ('Interleaving Faktor eingeben [1..',Sektoren_pro_Spur,'] : ');
    readln(inter);
  until ((inter > 0) and (inter <= Sektoren_pro_Spur));
  for i := 1 to (Sektor_Laenge+1) do buffer[i] := 0;
  first := 0;
  Sek_Num := 0;
  for i:= 1 to Sektoren_pro_Spur do begin
    Buffer[(2*Sek_Num)+2] := lo(i);
    Sek_Num := Sek_Num + inter;
    if Sek_Num >= Sektoren_pro_Spur then begin
      first := first + 1;
      Sek_Num := first;
    end;
  end;
  writeln;
  for i := 1 to (Sektoren_pro_Spur) do begin
    write(buffer[(2*i)]:2,' ');
  end;
end;

procedure Formatiere_Spur (Spur : integer);
var Zylinder, Kopf : integer;
    tmp            : integer;
begin
  tmp := Gap3_Len - 3;
  if tmp < 0 then tmp := 0;
  Zylinder := Spur div Anzahl_Koepfe;
  if Kopf >= Anzahl_Koepfe then Kopf := 0;
  write(chr($0d),'Zylinder = ',Zylinder:4,' Kopf = ',(Kopf+1):1);
  Update_Task_Register(Zylinder,Kopf,tmp);
  Set_Sectorcount (Sektoren_pro_Spur);
  HDC_Format;
  Send_Data_to_HDC;
  Test_Status(true);
  Kopf := Kopf+1;
end;

procedure Fuelle_Sektoren(Spur : integer);
var Zylinder,Kopf,Sektor : integer;
begin
  Zylinder := Spur div Anzahl_Koepfe;
  if Kopf >= Anzahl_Koepfe then Kopf := 0;
  write(chr($0d),'Zylinder = ',Zylinder:4,' Kopf = ',(Kopf+1):1);
  for Sektor := 1 to Sektoren_pro_Spur do begin
    Update_Task_Register(Zylinder,Kopf,Sektor);
    Set_Sectorcount(0);
    HDC_Write;
    Test_Status(false);
    HDC_Read;
    Test_Status(false);
  end;
  Kopf := Kopf+1;
end;

procedure Init_Format;
begin
{  HDC_Init; }
  Setup_Buffer;
  Compute_Gap3_Len;
  checkspace;
  HDC_Init;
  maxtrack := Anzahl_Koepfe * Anzahl_Zylinder;
end;

procedure DoFormat;
var spur : integer;
    kopf_u,kopf_o,spur_u,spur_o,sektor_u,sektor_o : integer;
    kopf_l,spur_l,sektor_l : integer;
begin
  Init_Format;
  writeln; writeln ('Formatierbereichs - Eingabe');
  repeat
    begin write ('Kopf (1-',Anzahl_Koepfe:1,')   :  ');
          read(kopf_u); write ('-'); read(kopf_o); writeln; end;
  until (kopf_u > 0) and (kopf_o <= Anzahl_Koepfe);
  repeat
    begin write ('Spur (0-',(Anzahl_Zylinder-1):3,') :  ');
          read(spur_u); write ('-'); read(spur_o); writeln; end;
  until (spur_u >= 0) and (spur_o <= Anzahl_Zylinder);
  writeln;
  writeln('Formatieren beginnt : ');
  kopf_l := 0;
  for spur_l := spur_u to spur_o do
    begin
    for kopf_l := kopf_u-1 to kopf_o-1 do
      begin
      spur :=(kopf_l and (Anzahl_Koepfe-1)) or (spur_l * Anzahl_Koepfe);
      Formatiere_Spur(Spur);
      end;
    end;
  writeln;
  writeln ('HD ist formatiert . ');
  writeln;
  writeln ('Die Sektoren werden jetzt mit E5H gefuellt : ');
  Clear_Buffer;
  kopf_l := 0;
  for spur_l := spur_O downto spur_u do
    begin
    for kopf_l := kopf_o-1 downto kopf_u-1 do
      begin
      spur := (kopf_l and (Anzahl_Koepfe-1)) or (spur_l * Anzahl_Koepfe);
      Fuelle_Sektoren(Spur);
      end;
    end;
  writeln; writeln;
  writeln ('HDformat beendet.');
end;

{ *** M A I N *** }
begin
  clrscr;
  writeln (drive_type,', Formatter v1.0 - 30.12.1990');
  writeln;
  writeln ('  ***  A C H T U N G ! ***');
  writeln;
  writeln ('Alle Daten auf der Hard-Disk werden geloescht.');
  writeln ('Formatiervorgang selbst kann nur mit ^S^C abgebrochen werden.');
  writeln ('Bitte Geduld, es dauert...');
  writeln;
  writeln ('Start = <CR>, Abbruch = <ESC>');
  if keypressed then read(kbd,ch);
  read(kbd,ch);
  writeln;
  if ch = CR then begin
    DoFormat;
  end else begin
    writeln;
    writeln ('Formatieren wurde abgebrochen !');
  end;
  HDC_Deselect;
end.

